=== debian/changelog ===
kleidiai (1.8.0+ds-1) unstable; urgency=medium

  * New upstream version 1.8.0+ds.
  * d/patches: refresh existing patches.

 -- Shengqi Chen <harry@debian.org>  Fri, 02 May 2025 16:35:03 +0800

kleidiai (1.6.0+ds-3) unstable; urgency=medium

  * d/control: set maintainer to deep learning team.
  * d/patches: update cmake patch to disable LTO.
  * d/rules: explicitly disable LTO.

 -- Shengqi Chen <harry@debian.org>  Fri, 25 Apr 2025 14:47:41 +0800

kleidiai (1.6.0+ds-2) unstable; urgency=medium

  * Source-only upload to allow migration. 

 -- Shengqi Chen <harry@debian.org>  Sun, 13 Apr 2025 09:59:52 +0800

kleidiai (1.6.0+ds-1) unstable; urgency=medium

  * Initial packaging for kleidiai (closes: #1081414).

 -- Shengqi Chen <harry@debian.org>  Sat, 12 Apr 2025 20:55:57 +0800
