=== debian/watch ===
version=4
 opts="repack,dversionmangle=auto,repacksuffix=+ds" \
 https://github.com/ARM-software/kleidiai/tags .*/@ANY_VERSION@@ARCHIVE_EXT@
