=== debian/changelog ===
kleidiai (1.15.1+ds-1) unstable; urgency=medium

  * d/watch: switch to version 5.
  * New upstream version 1.15.1+ds.
  * d/patches: refresh existing patches.

 -- Shengqi Chen <harry@debian.org>  Sat, 25 Oct 2025 19:31:52 +0800
