=== debian/control ===
Source: kleidiai
Section: utils
Priority: optional
Standards-Version: 4.7.2
Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Shengqi Chen <harry@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 ninja-build,
 libgtest-dev <!nocheck>,
Homepage: https://gitlab.arm.com/kleidi/kleidiai
Vcs-Git: https://salsa.debian.org/deeplearning-team/kleidiai.git
Vcs-Browser: https://salsa.debian.org/deeplearning-team/kleidiai
Rules-Requires-Root: no

Package: libkleidiai-dev
Section: libdevel
Architecture: arm64
Multi-Arch: same
Depends: ${misc:Depends}
Description: Optimized micro-kernel library for AI workloads for Arm CPUs (development files)
 KleidiAI is an open-source library that provides optimized
 performance-critical routines, also known as micro-kernels,
 for artificial intelligence (AI) workloads tailored for Arm CPUs.
 .
 This package contains the development files of libkleidiai.
