=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
DPKG_EXPORT_BUILDFLAGS = 1

include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

%:
	dh $@ --buildsystem=cmake+ninja --builddir=build

override_dh_auto_configure:
	dh_auto_configure -- -DKLEIDIAI_BUILD_TESTS=ON -DCMAKE_INSTALL_LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH) -DCMAKE_INSTALL_INCLUDEDIR=/usr/include/$(DEB_HOST_MULTIARCH)

override_dh_auto_test:
# running all tests is too slow, choose some essential ones
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	env GTEST_FILTER='MatMul/MatMulTest.*' dh_auto_test
endif
