=== debian/watch ===
Version: 5
Template: GitHub
Owner: ARM-software
Project: kleidiai
# skip versions that have '-' in it (e.g. -rc1)
MatchingPattern: https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/v((?:\d\.?)+)
RepackSuffix: +ds
