## kleidiai 1.19.0%2Bds

=== debian/rules ===
--- 
+++ 
@@ -15,5 +15,5 @@
 override_dh_auto_test:
 # running all tests is too slow, choose some essential ones
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-	env GTEST_FILTER='MatMul/MatMulTest.*' dh_auto_test
+	env GTEST_FILTER='MatMul/MatMulTest.*:-*sme*:*sve*' dh_auto_test
 endif
