=== debian/changelog ===
kleidiai (1.19.0+ds-1) unstable; urgency=medium

  * New upstream version 1.19.0+ds.
  * d/rules: disable tests with unsupported ISAs (SVE/SME).
  * d/control: bump std-ver to 4.7.3 (no changes).

 -- Shengqi Chen <harry@debian.org>  Mon, 29 Dec 2025 17:10:17 +0800
