=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: kleidiai
 Section: utils
 Priority: optional
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
 Uploaders: Shengqi Chen <harry@debian.org>
 Build-Depends:
@@ -12,7 +12,6 @@
 Homepage: https://gitlab.arm.com/kleidi/kleidiai
 Vcs-Git: https://salsa.debian.org/deeplearning-team/kleidiai.git
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/kleidiai
-Rules-Requires-Root: no
 
 Package: libkleidiai-dev
 Section: libdevel
